# @react-formbuild-component
react-formbuild-component is a React library for dealing with Forms

## Default props of the Component
`````
<FormBuild
 error={error} Error messages comming from the Redux Store (usually)
 abmStatus={abmStatus} Status of the abm Coming from the Redux Store (usually)
 siteKey={siteKey}  Sitekey needed for GoogleCaptcha functionality (only needed when captcha is enabled on the Json form)
 jsonForm={jsonForm}    
 token={token}  Auth Token needed for http get when Select option consumes from external api (Only needed when Select has a source endpoint)
/>
`````

  #   WorkFlow
  
  
  ``
     1-Create a Json Model to be saved in src/model/data/"name of the View that will consume the Json, there are many examples on the doc/examples/json folder."
  ``
    
  `` 
     2-Choose where you want to host the json: 
  ``
      
  `` 
     3-Use the component on the render area
  ``
      
  `` 
    4-Create a button and paste the handleOnSubmit
  ``
     
         const submit = {
                    name: 'submit',
                    onSubmit: values => {
                        this.handlerOnSubmit(values);
                    }
                };
  ``
     5-Link the handler into the Json form Using the lodash Library (Should be imported before hand)
  ``
  
  ```
  Object.assign(formJSON[0].buttons[0], formJSON[0].buttons[0], submit);
  ```   

``
6-Create the logic that handles the onUpdate
``
```
        if (this.props.update) {
        const onUpdate = {
            fields: [
                        {
                            value: this.prop.value
                            placeholder: this.prop.somthing,
                        }, 
                        {
                            value: this.prop.value
                            placeholder: this.prop.placeholder,
                        }
            ]
        }
  ```
   ``
   7- Merge onupdate values into json form (same step 5 but for fields)
   ``
    
   ``
   8-Link the handler into the Json form Using the lodash Library (Should be imported before hand)
   ``
   
   ```
   Object.assign(formJSON[0].fields, formJSON[0].fields, onUpdate);
   ```
     
     
   ``
   9- Let the FormBuilder render the Json
   `` 
